#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct tripl {
  int x = -1;
  int y = -1;
  int z = -1;
};
struct doubl {
  int x = -1;
  int y = -1;
};

tripl make_tripl(int x, int y, int z){
  tripl tr;
  tr.x = x;
  tr.y = y;
  tr.z = z;
  
  return tr;
}
doubl make_doubl(int x, int y){
  doubl dbl;
  dbl.x = x;
  dbl.y = y;
  
  return dbl;
}

int main() {
  int n, k = -1, t = -1;
  cin >> n;
  vector<int> dots (80, 0);
  vector<int> dots_temp (80, 0);
  vector<tripl> ands;
  vector<doubl> nots;
  
  for(int i = 0, j, j1, j2, j3; i < n; i++){
    cin >> j;
    switch (j) {
      case 0:
        cin >> j1 >> j2;
        dots[j1] = j2;
        break;
      case 1:
        cin >> j1 >> j2;
        nots.push_back(make_doubl(j1, j2));
        break;
      case 2:
        cin >> j1 >> j2 >> j3;
        ands.push_back(make_tripl(j1, j2, j3));
        break;
      case 3:
        cin >> k >> t;
        break;
    }
  }
  dots_temp = dots;
  
  for(int j = 0; j < nots.size(); j++){
    dots_temp[nots[j].y] = 0;
  }
  for(int j = 0; j < ands.size(); j++){
    dots_temp[ands[j].z] = 0;
  }
  for(int i = 0; i < t; i++){
    for(int j = 0; j < nots.size(); j++){
      dots_temp[nots[j].y] = (!dots[nots[j].x] || dots_temp[nots[j].y]);
    }
    for(int j = 0; j < ands.size(); j++){
      dots_temp[ands[j].z] = ((dots[ands[j].x] && dots[ands[j].y]) || dots_temp[ands[j].z]);
    }
    dots = dots_temp;

    for(int j = 0; j < nots.size(); j++){
      dots_temp[nots[j].y] = 0;
    }
    for(int j = 0; j < ands.size(); j++){
      dots_temp[ands[j].z] = 0;
    }
    cout << dots[k] << "\n";
  }
  return 0;
}
